import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'custom-multiflipcard.dart';

class TileData {
  Widget leading;
  String title;
  String subtitle;
  Widget trailing;
  bool enabled;
  bool selected;

  TileData(
      {this.leading,
      this.title,
      this.subtitle,
      this.trailing,
      this.enabled = true,
      this.selected = false});
}

class ListTileParameters {
  final bool isThreeLine;
  final bool dense;
  final EdgeInsetsGeometry contentPadding;
  final GestureTapCallback onTap;
  final GestureLongPressCallback onLongPress;

  ListTileParameters({
    this.isThreeLine = false,
    this.dense,
    this.contentPadding,
    this.onTap,
    this.onLongPress,
  });
}

class CustomDividerParameters {
  final double height;
  final double thickness;
  final double indent;
  final double endIndent;
  final Color color;

  const CustomDividerParameters({
    this.height,
    this.thickness,
    this.indent,
    this.endIndent,
    this.color,
  });
}

class CustomToolTipParams {
  final String message;
  final Widget child;
  final double height;
  final EdgeInsetsGeometry padding;
  final EdgeInsetsGeometry margin;
  final double verticalOffset;
  final bool preferBelow;
  final bool excludeFromSemantics;
  final Decoration decoration;
  final TextStyle textStyle;
  final Duration waitDuration;
  final Duration showDuration;

  const CustomToolTipParams(
      {this.message,
      this.child,
      this.height,
      this.padding,
      this.margin,
      this.verticalOffset,
      this.preferBelow,
      this.excludeFromSemantics,
      this.decoration,
      this.textStyle,
      this.waitDuration,
      this.showDuration});
}


class CustomLinearProgressBarParameters {
  final double value;
  final Color backgroundColor;
  final Animation<Color> valueColor;
  final String semanticsLabel;
  final String semanticsValue;

  const CustomLinearProgressBarParameters({
    Key key,
    this.value,
    this.backgroundColor,
    this.valueColor,
    this.semanticsLabel,
    this.semanticsValue,
  });
}

class CustomCircularProgressIndicatorParameters {
  final double value;
  final Color backgroundColor;
  final Color valueColor;
  final String semanticsLabel;
  final String semanticsValue;

  CustomCircularProgressIndicatorParameters(
      {this.value,
      this.backgroundColor,
      this.valueColor,
      this.semanticsLabel,
      this.semanticsValue});
}


class Products {
  String imagepath;
  String Text1;
  String Text2;
  String Text3;
  String Text4;

  Products(this.imagepath, this.Text1, this.Text2, this.Text3, this.Text4);
}

class ListItems {
  IconData icon;
  String Text1;

  ListItems(this.icon, this.Text1);
}

class User {
  String imagepath;
  String username;
  String useremailid;
  FontWeight fontWeight;
  double fontSize;
  Color fontColor;
  Color headerColor;

  User(this.imagepath, this.username, this.useremailid, this.fontColor,
      this.fontWeight, this.fontSize, this.headerColor);
}

class VTabBarProducts {
  String text;
  IconData icons;
  Widget widget;

  VTabBarProducts(this.text, this.icons, this.widget);
}


class ButtonBarParameters {
  List<ButtonBarList> list;
  Color ButtonbgColor;
  Color textColor;
  Color disabledTextColor;
  double  highlightElevation;
  double elevation;
  double disabledElevation;
 Color hoverColor;
  Color borderColor;
  double borderWidth;
  Color focusColor;
  double button_borderRadius;
  ButtonBarParameters({this.list,this.ButtonbgColor,this.textColor,
      this.disabledTextColor,this.highlightElevation,this.elevation,
      this.disabledElevation,this.hoverColor,this.borderColor,this.borderWidth,
      this.focusColor,this.button_borderRadius});
}
class ButtonBarList{
  String text;
  Icon icons;
  ButtonBarList(this.text,this.icons);

}


class TabBarViewParameters {
  Color backgroundColor;
  Color labelColor;
  Color indicatorColor;
  Color unselectedLabelColor;
  Color boxShadowColor;
  Color borderColor;
  double borderWidth;
  Color boxColor;
  BorderRadiusGeometry borderRadius;
  List<TabBarProducts> listTabs;


  TabBarViewParameters({this.backgroundColor,
    this.labelColor,
    this.indicatorColor,
    this.unselectedLabelColor,
    this.boxShadowColor,
    this.borderColor,
    this.borderWidth,
    this.boxColor,
    this.borderRadius,
    this.listTabs,
  }
      );
}
class TabBarProducts {
  String text;
  Icon icons;
  Widget widget;


  TabBarProducts(this.text, this.icons, this.widget);
}

class TabBarParameters {
  Color backgroundColor;
  Color labelColor;
  Color indicatorColor;
  Color unselectedLabelColor;
  Color boxShadowColor;
  Color borderColor;
  double borderWidth;
  Color boxColor;
  BorderRadiusGeometry borderRadius;
  List<TabBarList> tablist;


  TabBarParameters({this.backgroundColor,
    this.labelColor,
    this.indicatorColor,
    this.unselectedLabelColor,
    this.boxShadowColor,
    this.borderColor,
    this.borderWidth,
    this.boxColor,
    this.borderRadius,
    this.tablist,
  }
      );

}
class TabBarList{
  String text;
  Icon icons;
  TabBarList(this.text, this.icons);
}


class AppBarParameters {
  final Widget leading;
  final bool automaticallyImplyLeading;
  final Widget title;
  final List<Widget> actions;
  final Widget flexibleSpace;
  PreferredSizeWidget bottom;
  final double elevation;
  final ShapeBorder shape;
  final Color backgroundColor;
  final Brightness brightness;
  final IconThemeData iconTheme;
  final IconThemeData actionsIconTheme;
  final TextTheme textTheme;
  final bool primary;
  final bool centerTitle;
  final bool excludeHeaderSemantics;
  final double titleSpacing;
  final double toolbarOpacity;
  final double bottomOpacity;
  Widget searchBar;

  AppBarParameters(
      {this.leading,
      this.automaticallyImplyLeading,
      this.title,
      this.actions,
      this.flexibleSpace,
      this.bottom,
      this.elevation,
      this.shape,
      this.backgroundColor,
      this.brightness,
      this.iconTheme,
      this.actionsIconTheme,
      this.textTheme,
      this.primary,
      this.centerTitle,
      this.excludeHeaderSemantics,
      this.titleSpacing,
      this.toolbarOpacity,
      this.bottomOpacity,
      this.searchBar});
}

class BottomNavBarParameters {
  final List<BottomNavigationBarItem> items;
  final ValueChanged onTap;
  final int currentIndex;
  final double elevation;
  final BottomNavigationBarType type;
  final Color fixedColor;
  final Color backgroundColor;
  final double iconSize;
  final Color selectedItemColor;
  final Color unselectedItemColor;
  final IconThemeData selectedIconTheme;
  final IconThemeData unselectedIconTheme;
  final double selectedFontSize;
  final double unselectedFontSize;
  final TextStyle selectedLabelStyle;
  final TextStyle unselectedLabelStyle;
  final bool showSelectedLabels;
  final bool showUnselectedLabels;

  BottomNavBarParameters({
    this.items,
    this.onTap,
    this.currentIndex,
    this.elevation,
    this.type,
    this.fixedColor,
    this.backgroundColor,
    this.iconSize,
    this.selectedItemColor,
    this.unselectedItemColor,
    this.selectedIconTheme,
    this.unselectedIconTheme,
    this.selectedFontSize,
    this.unselectedFontSize,
    this.selectedLabelStyle,
    this.unselectedLabelStyle,
    this.showSelectedLabels,
    this.showUnselectedLabels,
  });
}

class SliverAppBarParameters {
  final Widget leading;
  final bool automaticallyImplyLeading;
  final Widget title;
  final List<Widget> actions;
  final Widget flexibleSpace;
  PreferredSizeWidget bottom;
  final double elevation;
  final bool forceElevated;
  final Color backgroundColor;
  final Brightness brightness;
  final IconThemeData iconTheme;
  final IconThemeData actionsIconTheme;
  final TextTheme textTheme;
  final bool primary;
  final bool centerTitle;
  final bool excludeHeaderSemantics;
  final double titleSpacing;
  final double expandedHeight;
  final bool floating;
  final bool pinned;
  final bool snap;
  final bool stretch;
  final double stretchTriggerOffset;
  final AsyncCallback onStretchTrigger;
  final ShapeBorder shape;

  SliverAppBarParameters(
      {this.leading,
      this.automaticallyImplyLeading,
      this.title,
      this.actions,
      this.flexibleSpace,
      this.bottom,
      this.elevation,
      this.forceElevated,
      this.backgroundColor,
      this.brightness,
      this.iconTheme,
      this.actionsIconTheme,
      this.textTheme,
      this.primary,
      this.centerTitle,
      this.excludeHeaderSemantics,
      this.titleSpacing,
      this.expandedHeight,
      this.floating,
      this.pinned,
      this.snap,
      this.stretch,
      this.stretchTriggerOffset,
      this.onStretchTrigger,
      this.shape});
}

class CarouselClass {
  Widget widget;
  String Text1;
  Animation animation;

  CarouselClass({this.widget, this.Text1, this.animation});
}

class CarouselClass1 {
  Widget widget;
  String Text1;
  Cubic animation;
  Duration animationDuration;
  CarouselClass1(
      {this.widget, this.Text1, this.animation, this.animationDuration});
}

class CustomCompositeCardParameters {
  int flexColumn1;
  int flexColumn2;
  String title;
  String subtitle;
  List<Widget> leftHandWidgets;
  List<Widget> rightHandWidgets;
  double margin;
  double elevation;
  Color cardColor;
  Color shadowColor;
  double shadowSpread;
  double textSpacing;

  CustomCompositeCardParameters(
      {this.flexColumn1,
      this.flexColumn2,
      this.title,
      this.subtitle,
      this.leftHandWidgets,
      this.rightHandWidgets,
      this.margin,
      this.elevation,
      this.cardColor,
      this.shadowColor,
      this.shadowSpread,
      this.textSpacing});
}

class SliderParameters {
  final String label;
  final Color activeColor;
  final int divisions;
  final Color inactiveColor;
  final double max;
  final double min;
  final ValueChanged<double> onChanged;
  final ValueChanged<double> onChangeEnd;
  final ValueChanged<double> onChangeStart;
  final SemanticFormatterCallback semanticFormatterCallback;
  final double value;
  SliderParameters({
    Key key,
    this.label,
    this.activeColor,
    this.divisions,
    this.inactiveColor,
    this.max,
    this.min,
    this.onChanged,
    this.onChangeEnd,
    this.onChangeStart,
    this.semanticFormatterCallback,
    this.value,
  });
}

class AlertDialogContents {
  List<Widget> buttons;
  String Content;
  Widget title;

  AlertDialogContents(
      this.buttons, this.Content, this.title);
}

class AlertDialogParameters {
  final Widget title;
  final EdgeInsetsGeometry titlePadding;
  final TextStyle titleTextStyle;
  final Widget content;
  final EdgeInsetsGeometry contentPadding;
  final TextStyle contentTextStyle;
  final List<Widget> actions;
  final EdgeInsetsGeometry actionsPadding;
  final VerticalDirection actionsOverflowDirection;
  final double actionsOverflowButtonSpacing;
  final EdgeInsetsGeometry buttonPadding;
  final Color backgroundColor;
  final double elevation;
  final String semanticLabel;
  final EdgeInsets insetPadding;
  final Clip clipBehavior;
  final ShapeBorder shape;
  final bool scrollable;
  final double height;
  final double width;

  AlertDialogParameters({
    Key key,
    this.title,
    this.titlePadding,
    this.titleTextStyle,
    this.content,
    this.contentPadding = const EdgeInsets.fromLTRB(24.0, 20.0, 24.0, 24.0),
    this.contentTextStyle,
    this.actions,
    this.actionsPadding = EdgeInsets.zero,
    this.actionsOverflowDirection,
    this.actionsOverflowButtonSpacing,
    this.buttonPadding,
    this.backgroundColor,
    this.elevation,
    this.semanticLabel,
    this.insetPadding,
    this.clipBehavior = Clip.none,
    this.shape,
    this.scrollable = false,
    this.height,
    this.width,
  });
}

class BottomSheetContents {
  IconButton IconB;
  String Text1;

  BottomSheetContents(this.IconB, this.Text1);
}

class BottomSheetParameters {
  final AnimationController animationController;
  final bool enableDrag;
  final Color backgroundColor;
  final double elevation;
  final ShapeBorder shape;
  final Clip clipBehavior;
  final VoidCallback onClosing;
  final WidgetBuilder builder;
  final double itemExtent;
  final double height;
  final Color iconColor;
  final Color fontColor;
  final double contentSize;

  BottomSheetParameters({
    Key key,
    this.animationController,
    this.enableDrag = true,
    this.backgroundColor,
    this.elevation,
    this.shape,
    this.clipBehavior,
    this.onClosing,
    this.builder,
    this.itemExtent,
    this.height,
    this.fontColor,
    this.iconColor,
    this.contentSize
  });
}
class SwitchParameters {
  final ImageProvider activeThumbImage;
  final Color activeColor;
  final Color activeTrackColor;
  final Color focusColor;
  final Color hoveColor;
  final Color inactiveTrackColor;
  final bool autofocus;
  final FocusNode focusNode;
  final ImageProvider inactiveThumbImage;
  final MaterialTapTargetSize materialTapTargetSize;
  final ImageErrorListener onActiveThumbImageError;
  final ValueChanged<bool> onChanged;
  final ImageErrorListener onInactiveThumbImageError;
  final bool value;

  SwitchParameters({
    Key key,
    this.activeThumbImage,
    @required this.activeColor,
    this.materialTapTargetSize,
    this.focusNode,
    this.autofocus,
    this.onChanged,
    this.value,
    @required this.activeTrackColor,
    this.focusColor,
    this.hoveColor,
    this.inactiveThumbImage,
    this.inactiveTrackColor,
    this.onActiveThumbImageError,
    this.onInactiveThumbImageError,
  });
}

class TextFieldParameters {
  final bool autocorrect;
  final bool autofocus;
  final InputCounterWidgetBuilder buildCounter;
  final TextEditingController controller;
  final Color cursorColor;
  final Radius cursorRadius;
  final double cursorWidth;
  final InputDecoration decoration;
  final bool enabled;
  final bool enableInteractiveSelection;
  final bool enableSuggestions;
  final bool expands;
  final FocusNode focusNode;
  final Brightness keyboardAppearances;
  final TextInputType keyboardType;
  final int maxLength;
  final bool maxLengthEnforced;
  final int maxLines;
  final int minLines;
  final bool obsecureText;
  final ValueChanged<String> onChanged;
  final VoidCallback onEditingComplete;
  final ValueChanged<String> onSubmitted;
  final GestureTapCallback onTap;
  final bool readOnly;
  final ScrollController scrollController;
  final EdgeInsets scrollPadding;
  final ScrollPhysics scrollPhysics;
  final bool selectionEnabled;
  final bool showCursor;
  final StrutStyle strutStyle;
  final TextStyle style;
  final TextAlign textAlign;
  final TextAlignVertical textAlignVertical;
  final TextCapitalization textCapitalization;
  final TextDirection textDirection;
  final TextInputAction textInputAction;
  final ToolbarOptions toolbarOptions;

  TextFieldParameters({
    Key key,
    this.toolbarOptions,
    this.textInputAction,
    this.textDirection,
    this.textCapitalization,
    this.textAlignVertical,
    this.textAlign,
    this.style,
    this.strutStyle,
    this.scrollPhysics,
    this.scrollController,
    this.focusNode,
    this.decoration,
    this.controller,
    this.onChanged,
    this.autocorrect,
    this.autofocus,
    this.buildCounter,
    this.cursorColor,
    this.cursorRadius,
    this.cursorWidth,
    this.enabled,
    this.enableInteractiveSelection,
    this.enableSuggestions,
    this.expands,
    this.keyboardAppearances,
    this.keyboardType,
    this.maxLength,
    this.maxLengthEnforced,
    this.maxLines,
    this.minLines,
    this.obsecureText,
    this.onEditingComplete,
    this.onSubmitted,
    this.onTap,
    this.readOnly,
    this.scrollPadding,
    this.selectionEnabled,
    this.showCursor,
  });
}

class CustomImageContents{
  final String src;
  final Key key;
  final double scale = 1.0;
  final ImageFrameBuilder frameBuilder;
  final ImageLoadingBuilder loadingBuilder;
  final ImageErrorListener errorBuilder;
  final String semanticLabel;
  final bool excludeFromSemantics;
  final double width;
  final double height;
  final Color color;
  final BlendMode colorBlendMode;
  final BoxFit fit;
  final AlignmentGeometry alignment;
  final ImageRepeat repeat;
  final Rect centerSlice;
  final bool matchTextDirection;
  final bool gaplessPlayback;
  final FilterQuality filterQuality;
  final Map<String, String> headers;
  final int cacheWidth;
  final int cacheHeight;
  final String imageType;

  CustomImageContents({
    this.frameBuilder,
    this.loadingBuilder,
    this.errorBuilder,
    @required this.semanticLabel,
    this.excludeFromSemantics = false,
    this.width,
    this.height,
    this.color,
    this.colorBlendMode,
    this.fit,
    this.alignment = Alignment.center,
    this.repeat = ImageRepeat.noRepeat,
    this.centerSlice,
    this.matchTextDirection = false,
    this.gaplessPlayback = false,
    this.filterQuality = FilterQuality.low,
    this.key,
    this.headers,
    this.cacheWidth,
    this.cacheHeight,
    @required this.src,
    @required this.imageType,
  });
}


class MaterialCardData {
  List<Widget> btnGrpList1;
  List<Widget> btnGrpList2;
  String imgPath;
  String headerText;
  String title;
  String subtitle;
  String bodyText;
  String footerText;
  String btnText;
  String btnTextOne;
  String btnTextTwo;
  String btnViewone;
  String btnViewtwo;
  String btnViewthree;
  Icon icon;
  double imgHeight;
  double imgWidth;
  double containerHeight;
  double containerWidth;
  TextStyle textStyle1;
  TextStyle textStyle2;
  TextStyle textStyle3;
  TextStyle textStyle4;
  TextStyle textStyle5;
  Decoration imgDecoration;
  Decoration iconbgDecoration;
  Decoration containerDecoration;
  String imgType;
  Color cardbgColor;
  Color containerbgColor;
  Color dividerColor;
  Color ratingBarColor;
  double initialRating;
  void Function(double) onRatingUpdate;
  bool iconVisibility;
  bool visibilityCardHeaderTile;
  bool visibilityCardImage;
  bool visibilityCardFooter;
  bool visibilityCardData;
  bool visibilityCardActionBar;
  FlipDirection flipDirection;
  int flipSpeed;
  Decoration Decoration1;
  Decoration Decoration2;
  double margin1;
  double margin2;
  double margin3;
  double margin4;
  double padding1;
  double padding2;
  double padding3;
  double padding4;
  Color btnColor;
  ShapeBorder shapeButton;
  double cardOpacity;
  double elevation;
  Color btnTextColor;
  int imageFlex;
  int text1Flex;
  int text2Flex;
  int text3Flex;
  int text4Flex;
  double borderRadius;
  double borderWidth;
  Color borderColor;
  BoxShadow boxShadow;

  MaterialCardData({
    @required this.btnGrpList1,
    @required this.btnGrpList2,
    @required this.imgPath,
    @required this.headerText,
    @required this.title,
    @required this.subtitle,
    @required this.bodyText,
    @required this.footerText,
    @required this.btnText,
    @required this.icon,
    @required this.imgHeight,
    @required this.imgWidth,
    @required this.containerHeight,
    @required this.containerWidth,
    @required this.textStyle1,
    @required this.textStyle2,
    @required this.textStyle3,
    @required this.textStyle4,
    @required this.textStyle5,
    @required this.btnViewone,
    @required this.imgDecoration,
    @required this.iconbgDecoration,
    @required this.containerDecoration,
    @required this.imgType,
    @required this.btnTextTwo,
    @required this.cardbgColor,
    @required this.containerbgColor,
    @required this.btnTextOne,
    @required this.btnViewtwo,
    @required this.btnViewthree,
    @required this.dividerColor,
    @required this.iconVisibility,
    @required this.visibilityCardHeaderTile,
    @required this.visibilityCardImage,
    @required this.visibilityCardFooter,
    @required this.visibilityCardData,
    @required this.visibilityCardActionBar,
    @required this.onRatingUpdate,
    @required this.flipSpeed,
    @required this.flipDirection,
    @required this.Decoration1,
    @required this.Decoration2,
    @required this.margin1,
    @required this.margin2,
    @required this.margin3,
    @required this.margin4,
    @required this.padding1,
    @required this.padding2,
    @required this.padding3,
    @required this.padding4,
    @required this.btnColor,
    @required this.shapeButton,
    @required this.elevation,
    @required this.cardOpacity,
    @required this.btnTextColor,
    @required this.initialRating,
    @required this.ratingBarColor,this.text4Flex,this.text3Flex,this.text2Flex,this.text1Flex,this.imageFlex,this.boxShadow,this.borderColor,this.borderWidth,this.borderRadius
  });
}


class PaginatedDataTableData {
  String headerText;
  bool sortAscending;
  int sortColumnIndex;
  double columnSpacing;
  double dataRowHeight;
  double horizontalMargin;
  List<int> availableRowsPerPage;
  List<DataColumn> columns;
  DataTableSource tableData;
  ThemeData theme;
  int rowsPerPage;
  List<Widget> actions;
  PaginatedDataTableData(
      {@required this.availableRowsPerPage,
        @required this.columnSpacing,
        @required this.dataRowHeight,
        @required this.horizontalMargin,
        @required this.rowsPerPage,
        @required this.tableData,
        @required this.headerText,
        @required this.sortAscending,
        @required this.sortColumnIndex,
        @required this.actions,
        @required this.theme,
        @required this.columns});
}

class SnackBarData {
  String snackBarButtonText;
  String snackBarContent;
  String snackBarLabel;
  Color bgColor;
  Color labelColor;
  Color textColor;
  ShapeBorder shapeBorder;
  int duration;

  SnackBarData(
      {@required this.snackBarButtonText,
        @required this.snackBarContent,
        @required this.snackBarLabel,
        @required this.bgColor,
        @required this.labelColor,
        @required this.textColor,
        @required this.shapeBorder,
        @required this.duration});
}

class ExpandablePanelData {
  final String title;
  final Icon icon;
  final List<Widget> widget;
  final ThemeData themeData;
  ExpandablePanelData(this.title, this.icon, this.widget, this.themeData);
}

class MaterialChipData {
  String labelText;
  String tooltipMsg;
  String deleteMsg;
  Color checkmarkColor;
  Color bgColor;
  Color labelColor;
  Color selectedbgColor;
  ShapeBorder shapeBorder;

  MaterialChipData(
      {@required this.labelText,
        @required this.tooltipMsg,
        @required this.deleteMsg,
        @required this.checkmarkColor,
        @required this.bgColor,
        @required this.labelColor,
        @required this.shapeBorder,
        @required this.selectedbgColor});
}

class SimpleDialogData {
  String dialogHeader;
  String dialogContent;
  String dialogButtonText;
  double height;
  double width;
  ShapeBorder shapeBorder;
  Color bgColor;
  Color headerTextColor;
  Color bodyTextColor;
  Color btnTextColor;
  Color btnColor;

  SimpleDialogData(
      {@required this.dialogHeader,
        @required this.dialogContent,
        @required this.dialogButtonText,
        @required this.height,
        @required this.width,
        @required this.shapeBorder,
        @required this.bgColor,
        @required this.headerTextColor,
        @required this.bodyTextColor,
        @required this.btnTextColor,
        @required this.btnColor});
}




class CustomTileData {
  Widget leading;
  String title;
  String subtitle;
  String trailingTopText;
  String trailingBottomText;
  bool enabled;
  bool selected;
  bool stubMode;

  CustomTileData(
      {this.leading,
      this.title,
      this.subtitle,
      this.trailingTopText,
      this.trailingBottomText,
      this.enabled = true,
      this.selected = false,
      this.stubMode = true});
}

class CustomListTileParameters {
  bool isThreeLine;
  bool dense;
  EdgeInsetsGeometry contentPadding;
  GestureTapCallback onTap;
  GestureLongPressCallback onLongPress;
  FontWeight fontWeight;
  double fontSize;
  String fontFamily;
  Color textColor;
  Color listBgColor;
  Color iconBgColor;
  double circularRadius;
  double listHeight;
  double listWidth;
  double iconHeight;
  double iconWidth;

  CustomListTileParameters(
      {this.isThreeLine = false,
      this.dense,
      this.contentPadding,
      this.onTap,
      this.onLongPress,
      this.textColor,
      this.fontFamily,
      this.fontWeight,
      this.fontSize,
      this.circularRadius,
      this.iconBgColor,
      this.listBgColor,
      this.listHeight,
      this.iconHeight,
      this.iconWidth,
      this.listWidth});
}

class DropDownParameters {
  String hintText;
  List<String> itemsList;
  String listType;
  Color textColor;
  Color hintTextColor;
  FontWeight hintFontWeight;
  FontStyle hintFontStyle;
  double hintFontSize;
  String hintfontFamily;
  Color fillColor;
  Color itemsBgColor;
  Color iconEnabledColor;
  TextAlign textAlign;
  double width;
  double height;
  double imageWidth;
  double imageHeight;
  String fontFamily;
  FontWeight fontWeight;
  FontStyle fontStyle;
  double fontSize;
  double shadowBlurRadius;
  double shadowSpreadRadius;
  double shadowOffsetX;
  double shadowOffsetY;
  double borderRadius;
  Color shadowColor;
  Key key;

  DropDownParameters(
      {@required this.itemsList,
      this.hintText,
      this.textColor,
      this.height,
      this.width,
      this.fontFamily,
      this.fontStyle,
      this.fontWeight,
      this.fontSize,
      this.fillColor,
      this.imageWidth,
      this.imageHeight,
      this.textAlign,
      this.shadowBlurRadius,
      this.shadowSpreadRadius,
      this.shadowOffsetX,
      this.shadowOffsetY,
      this.listType,
      this.borderRadius,
      this.itemsBgColor,
      this.iconEnabledColor,
      this.shadowColor,
      this.hintFontSize,
      this.hintFontStyle,
      this.hintFontWeight,
      this.hintTextColor,
      this.hintfontFamily,
      this.key});
}

class StepperParameters {
  ScrollPhysics physics;
  StepperType type;
  int currentStep;
  ValueChanged<int> onStepTapped;
  VoidCallback onStepContinue;
  VoidCallback onStepCancel;
  ControlsWidgetBuilder controlsBuilder;

  StepperParameters(
      {Key key,
      this.physics,
      this.type = StepperType.vertical,
      this.currentStep,
      this.onStepTapped,
      this.onStepContinue,
      this.onStepCancel,
      this.controlsBuilder});
}

class CustomSteps {
  Widget title;
  Widget subtitle;
  Widget content;
  StepState state;
  bool isActive;

  CustomSteps(
      {this.title, this.subtitle, this.content, this.state, this.isActive});
}

class CustomVerticalTabParameters {
  final Key key;
  final double tabsWidth;
  final double itemExtent;
  final double indicatorWidth;
  final TextDirection direction;
  final Color indicatorColor;
  final bool disabledChangePageFromContentView;
  final Axis contentScrollAxis;
  final Color selectedTabBackgroundColor;
  final Color unselectedTabBackgroundColor;
  final Color dividerColor;
  final Duration changePageDuration;
  final Curve changePageCurve;
  final Color tabsShadowColor;
  final double tabsElevation;
  final Color iconColor;
  final Color tabsTextColor;

  CustomVerticalTabParameters({
    this.key,
    this.tabsWidth,
    this.itemExtent,
    this.indicatorWidth,
    this.direction ,
    this.indicatorColor ,
    this.disabledChangePageFromContentView,
    this.contentScrollAxis ,
    this.selectedTabBackgroundColor,
    this.unselectedTabBackgroundColor,
    this.dividerColor,
    this.changePageCurve,
    this.changePageDuration,
    this.tabsShadowColor,
    this.tabsElevation,
    this.iconColor,
    this.tabsTextColor
});
}


class CustomFingerprintParameters{
  final Widget tapWidget;
  final String authText;
  final Color backgroundColor;
  final Color textColor;
  final double textSize;

  CustomFingerprintParameters({
   this.tapWidget, this.authText, this.backgroundColor, this.textColor, this.textSize
});
}


//Icon
class IconState {
  IconData icon;
  Color color;
  double size;

  IconState({this.icon, this.color, this.size});
}

//Sub-Widget model Definition
class Area {
  String header;
  Widget widget;
  String label;

  Area(this.header, this.widget, this.label);
}

//Grid model Definition
class Grid {
  int count;
  double crossaxisspacing;
  double mainaxisspacing;
  Color cardColour;
  Color textColour;
  final void Function(int, String) callback;
  final void Function(int, String, String) longcallback;
  Grid(
      {this.count,
      this.callback,
      this.longcallback,
      this.crossaxisspacing,
      this.mainaxisspacing,
      this.cardColour,
      this.textColour});
}


class CustomGrid {
  int count;
  double cas;
  double mas;
  String cardtype;
  final void Function(int, String) callback;
  final void Function(int, String, String) longcallback;
  CustomGrid(this.count, this.callback, this.longcallback, this.cas, this.mas,
      this.cardtype);
}

//Model for the DataTable
class DataTableSchema {
  RowColumn columns;
  int sortColumnIndex;
  bool sortAscending;
  List<RowColumn> rows;
  Color backgroundColour;
  Color rowtextColour;
  double rowtextSize;
  Color columntextColour;
  double columntextSize;

  DataTableSchema(
      {this.columns,
      this.sortColumnIndex,
      this.sortAscending,
      this.rows,
      this.backgroundColour,
      this.rowtextColour,
      this.columntextColour,
      this.columntextSize,
      this.rowtextSize});
}

//Model for rows
class RowColumn {
  List<String> rowcolumn;
  RowColumn(this.rowcolumn);
}

class CustomPainterParameters {
  Color color;
  StrokeCap strokeCap;
  final double strokeWidth;

  CustomPainterParameters({
    this.color,
    this.strokeCap,
    this.strokeWidth,
  });
}

class CustomCanvasOptionsParameters {
  double heightColor;
  double heightThickness;
  double widthColor;
  double widthThickness;
  double fontSizeColour;
  double fontSizeThickness;
  Color textColorColour;
  Color textColorThickness;
  Color bgColorColour;
  Color bgColorThickness;
  String fontFamilyColour;
  String fontFamilyThickness;
  FontWeight fontWeightColour;
  FontWeight fontWeightThickness;
  Color borderColor;
  double borderWidth;
  Color btnColor;

  CustomCanvasOptionsParameters(
      {this.bgColorColour,
      this.bgColorThickness,
      this.fontFamilyColour,
      this.fontFamilyThickness,
      this.fontSizeColour,
      this.fontSizeThickness,
      this.fontWeightColour,
      this.fontWeightThickness,
      this.heightColor,
      this.heightThickness,
      this.textColorColour,
      this.textColorThickness,
      this.widthColor,
      this.widthThickness,
      this.borderWidth,
      this.borderColor,
      this.btnColor});
}

class OpportunityDetailsCardData {
  double height;
  double width;
  String amount;
  String status;
  String heading;
  String headingValue;
  String subheadingOne;
  String subheadingValueOne;
  String subheadingTwo;
  String subheadingValueTwo;
  Widget subheadingIconOne;
  Widget subheadingIconTwo;
  Color backgroundColor;
  Color statusBackgroundColor;
  double cardRadius;
  double statusRadius;
  String headingTextFamily;
  String headingValueTextFamily;
  String subheadingOneTextFamily;
  String subheadingTwoTextFamily;
  String subheadingValueOneTextFamily;
  String subheadingValueTwoTextFamily;
  String statusTextFamily;
  double headingTextSize;
  double headingValueTextSize;
  double subheadingOneTextSize;
  double subheadingTwoTextSize;
  double subheadingValueOneTextSize;
  double subheadingValueTwoTextSize;
  double statusTextSize;
  FontWeight headingTextWeight;
  FontWeight headingValueTextWeight;
  FontWeight subheadingOneTextWeight;
  FontWeight subheadingTwoTextWeight;
  FontWeight subheadingValueOneTextWeight;
  FontWeight subheadingValueTwoTextWeight;
  FontWeight statusTextWeight;
  Color headingTextColor;
  Color headingValueTextColor;
  Color subheadingOneTextColor;
  Color subheadingTwoTextColor;
  Color subheadingValueOneTextColor;
  Color subheadingValueTwoTextColor;
  Color statusTextColor;
  bool shadow;
  Color shadowColor;
  double shadowOffset;
  Color border;
  String amountTextFamily;
  double amountTextSize;
  FontWeight amountTextWeight;
  Color amountTextColor;
  double cardWidth;
  double padding;

  OpportunityDetailsCardData(
      {this.height = 300,
      this.width = double.infinity,
      this.amount = 'INR 1.2 Crore',
      this.status = 'Won',
      this.heading = 'Account Name',
      this.headingValue = 'Company Name',
      this.subheadingOne = 'Close Date',
      this.subheadingValueOne = '18/05/2020',
      this.subheadingTwo = 'Record Status',
      this.subheadingValueTwo = 'Lock',
      this.subheadingIconOne,
      this.subheadingIconTwo,
      this.backgroundColor = Colors.white,
      this.statusBackgroundColor = Colors.black,
      this.cardRadius = 6,
      this.statusRadius = 30,
      this.headingTextFamily = 'Roboto',
      this.headingValueTextFamily = 'Roboto',
      this.subheadingOneTextFamily = 'Roboto',
      this.subheadingTwoTextFamily = 'Roboto',
      this.subheadingValueOneTextFamily = 'Roboto',
      this.subheadingValueTwoTextFamily = 'Roboto',
      this.statusTextFamily = 'Roboto',
      this.headingTextSize = 14,
      this.headingValueTextSize = 16,
      this.subheadingOneTextSize = 14,
      this.subheadingTwoTextSize = 14,
      this.subheadingValueOneTextSize = 14,
      this.subheadingValueTwoTextSize = 14,
      this.statusTextSize = 10,
      this.headingTextWeight = FontWeight.bold,
      this.headingValueTextWeight = FontWeight.normal,
      this.subheadingOneTextWeight = FontWeight.bold,
      this.subheadingTwoTextWeight = FontWeight.bold,
      this.subheadingValueOneTextWeight = FontWeight.normal,
      this.subheadingValueTwoTextWeight = FontWeight.normal,
      this.statusTextWeight = FontWeight.normal,
      this.headingTextColor = Colors.black,
      this.headingValueTextColor = Colors.black,
      this.subheadingOneTextColor = Colors.black,
      this.subheadingTwoTextColor = Colors.black,
      this.subheadingValueOneTextColor = Colors.black,
      this.subheadingValueTwoTextColor = Colors.black,
      this.statusTextColor = Colors.white,
      this.shadow = false,
      this.shadowColor = Colors.black,
      this.shadowOffset = 10,
      this.border = Colors.black,
      this.amountTextFamily = 'Roboto',
      this.amountTextSize = 14,
      this.amountTextWeight = FontWeight.bold,
      this.amountTextColor = Colors.orange,
      this.cardWidth = 300,
      this.padding = 20});
}


class CardWithLeftThumbnailData {
  Color cardBackgroundColor;
  double borderRadius;
  bool shadow;
  Color shadowColor;
  double shadowRadius;
  String heading;
  Color headingTextColor;
  double headingTextSize;
  FontWeight headingTextWeight;
  String headingTextFamily;
  double paddingValue;
  Widget icon;
  Color iconColor;
  double iconHeight;
  double iconWidth;
  double thumbnailHeight;
  double thumbnailWidth;
  Color iconBackgroundColor;
  Widget leftBottomWidget;
  Widget rightMiddleWidget;
  Widget rightBottomWidget;

  CardWithLeftThumbnailData(
      {this.cardBackgroundColor = Colors.black,
      this.borderRadius = 6,
      this.shadow = false,
      this.shadowColor = Colors.black,
      this.shadowRadius = 10,
      this.heading = 'Card Heading',
      this.headingTextColor = Colors.white,
      this.headingTextSize = 14,
      this.headingTextWeight = FontWeight.bold,
      this.headingTextFamily = 'Roboto',
      this.paddingValue = 20,
      this.icon,
      this.iconColor = Colors.black,
      this.iconHeight = 20,
      this.iconWidth = 20,
      this.thumbnailWidth = 50,
      this.thumbnailHeight = 50,
      this.iconBackgroundColor = Colors.white,
      this.leftBottomWidget,
      this.rightMiddleWidget,
      this.rightBottomWidget});
}

class StatusCardData {
  double cardHeight;
  double cardWidth;
  Color backgroundColor;
  String heading;
  String headingTextFamily;
  double headingTextSize;
  FontWeight headingTextWeight;
  Color headingTextColor;
  String subheading;
  String subheadingTextFamily;
  double subheadingTextSize;
  FontWeight subheadingTextWeight;
  Color subheadingTextColor;
  String status;
  String statusTextFamily;
  double statusTextSize;
  FontWeight statusTextWeight;
  Color statusTextColor;
  Color statusBackground;
  double cardRadius;
  double statusRadius;

  StatusCardData(
      {this.cardHeight = 300,
      this.cardWidth = 200,
      this.backgroundColor = Colors.white,
      this.heading = 'Card Heading',
      this.headingTextFamily = 'Roboto',
      this.headingTextSize = 20,
      this.headingTextWeight = FontWeight.normal,
      this.headingTextColor = Colors.white,
      this.subheading = 'Card Subheading',
      this.subheadingTextFamily = 'Roboto',
      this.subheadingTextSize = 14,
      this.subheadingTextWeight = FontWeight.bold,
      this.subheadingTextColor = Colors.white,
      this.status = 'Status',
      this.statusTextFamily = 'Roboto',
      this.statusTextSize = 10,
      this.statusTextWeight = FontWeight.normal,
      this.statusTextColor = Colors.black,
      this.statusBackground = Colors.white,
      this.cardRadius = 6,
      this.statusRadius = 30});
}

class PlaceLocation {
  final double latitude;
  final double longitude;
  final String address;

  const PlaceLocation({
    @required this.latitude,
    @required this.longitude,
    this.address,
  });
}

class ServicesData {
  final String serviceType;
  final int serviceNumber;
  final Color mColor;

  ServicesData(this.serviceType, this.serviceNumber, this.mColor);
}

class LinearSales {
  final int year;
  final int sales;

  LinearSales(this.year, this.sales);
}

class FlatButtonParameters {
  @required
  Widget child;
  Color color;
  Brightness colorBrightness;
  Color disabledColor;
  double disabledElevation;
  Color disabledTextColor;
  Color focusColor;
  FocusNode focusNode;
  double height;
  Color highlightColor;
  Color splashColor;
  Color hoverColor;
  Color textColor;
  bool autofocus;
  double width;
  ShapeBorder shape;
  ButtonTextTheme textTheme;
  Key key;

  FlatButtonParameters(
      {this.child,
      this.color,
      this.colorBrightness,
      this.disabledColor,
      this.disabledElevation,
      this.disabledTextColor,
      this.focusColor,
      this.focusNode,
      this.height,
      this.highlightColor,
      this.splashColor,
      this.textTheme,
      this.hoverColor,
      this.textColor,
      this.autofocus,
      this.shape,
      this.width,
      this.key});
}

class IconButtonParameters {
  Color color;
  IconData icon;
  double iconSize;
  Color focusColor;
  Color hoverColor;
  Color splashColor;
  Color highlightColor;
  Color disabledColor;
  AlignmentGeometry alignment;
  bool autofocus;
  String tooltip;

  IconButtonParameters(
      {this.iconSize,
      this.icon,
      this.color,
      this.disabledColor,
      this.hoverColor,
      this.focusColor,
      this.splashColor,
      this.highlightColor,
      this.alignment,
      this.autofocus,
      this.tooltip});
}

class Floatingactionbuttonparam {
  @required
  Widget child;
  Color backgroundColor;
  Color foregroundColor;
  bool isExtended;
  ShapeBorder shape;
  Color hoverColor;
  Color splashColor;
  Object heroTag;
  bool autofocus;
  double elevation;
  double hoverElevation;
  double highlightElevation;
  double focusElevation;
  double disabledElevation;
  FocusNode focusNode;
  Color focusColor;
  bool mini;
  String tooltip;
  void Function(bool) onPressed;

  Floatingactionbuttonparam(
      {this.backgroundColor,
      this.foregroundColor,
      this.isExtended = false,
      this.shape,
      this.hoverColor,
      this.splashColor,
      this.heroTag,
      this.focusNode,
      this.autofocus,
      this.child,
      this.focusColor,
      this.highlightElevation,
      this.elevation,
      this.mini,
      this.hoverElevation,
      this.focusElevation,
      this.disabledElevation,
      this.onPressed,
      this.tooltip});
}

class Outlinebuttonparam {
  @required
  Widget child;
  BorderSide borderSide;
  Color color;
  ShapeBorder shape;
  Color textColor;
  Color disabledTextColor;
  Color disabledBorderColor;
  Color highlightColor;
  Color hoverColor;
  Color splashColor;
  Color borderColor;
  Color highlightedBorderColor;
  Color focusColor;
  double borderWidth;
  BorderStyle borderStyle;
  double width;
  double height;
  bool autofocus;
  ButtonTextTheme textTheme;
  FocusNode focusNode;

  Outlinebuttonparam(
      {this.borderSide,
      this.shape,
      this.textColor,
      this.hoverColor,
      this.highlightColor,
      this.focusColor,
      this.color,
      this.splashColor,
      this.borderColor,
      this.borderStyle,
      this.borderWidth,
      this.height,
      this.width,
      this.child,
      this.autofocus,
      this.focusNode,
      this.disabledTextColor,
      this.highlightedBorderColor,
      this.disabledBorderColor,
      this.textTheme});
}

class DatePickerParameters {
  int startMonth;
  int startYear;
  int endMonth;
  int endYear;
  int initialMonth;
  int initialYear;
  Color headerColor;
  Color bodybgColor;
  String confirmText;
  String cancelText;
  String hintText;
  TextStyle hintTextStyle;
  TextStyle buttonTextStyle;
  TextStyle dayTextStyle;
  TextStyle monthTextStyle;
  TextStyle selectedDateStyle;
  Color onHeaderColor;
  Color onBodyColor;

  DatePickerParameters(
      {this.startMonth,
      this.startYear,
      this.endMonth,
      this.endYear,
      this.headerColor,
      this.bodybgColor,
      this.initialMonth,
      this.initialYear,this.hintText,this.cancelText,this.confirmText,this.buttonTextStyle,this.dayTextStyle,this.hintTextStyle,this.monthTextStyle,this.onBodyColor,this.onHeaderColor,this.selectedDateStyle});
}

class TimePickerParameters {
  Color headerColor;
  Color selectColor;
  Color bodybgColor;
  Color timeColor;
  Color buttonText;
  String fontFamily;
  double timeSize;
  FontWeight fontWeight;

  TimePickerParameters({
    this.headerColor,
    this.bodybgColor,
    this.fontFamily,
    this.fontWeight,
    this.timeColor,
    this.selectColor,
    this.buttonText,
    this.timeSize,
  });
}

class DrawerListItems {
  Widget leading;
  Widget title;

  DrawerListItems(this.leading, this.title);
}

class DrawerHeaderParameters {
  String imageType;
  String imagepath;
  String title;
  String subtitle;
  String fontFamily;
  FontWeight fontWeight;
  double fontSize;
  Color fontColor;
  Color headerColor;
  Color listbgColor;

  DrawerHeaderParameters(
      {this.fontFamily,
      this.imageType,
      this.imagepath,
      this.title,
      this.subtitle,
      this.fontColor,
      this.fontWeight,
      this.fontSize,
      this.headerColor,
      this.listbgColor});
}

class CarouselList {
  @required
  Widget widget;
  CarouselList({
    this.widget,
  });
}

class CarouselParameters {
  double height;
  double width;
  double childAspectRatio;
  CarouselParameters({this.height, this.width, this.childAspectRatio});
}



class GrantsData {
  final String year;
  final int grants;
  final Color mColor;

  GrantsData(this.year, this.grants, this.mColor);
}

class ScatterChartClass {
  final String datalabel;
  final int xValue;
  final double yPercentage;
  final double radius;
  final Color color;

  ScatterChartClass(
      this.datalabel, this.xValue, this.yPercentage, this.radius, this.color);
}
